unit kMLngReg;

interface
uses Classes, SysUtils, kMLang;

procedure Register;

implementation
uses TypInfo, DsgnIntf;

type
 TLangFileProperty = class(TPropertyEditor)
 public
   function GetAttributes : TPropertyAttributes;override;
   function GetValue: string; override;
   procedure SetValue(const Value: string); override;
   procedure GetValues(Proc : TGetStrProc);override;
 end;

function TLangFileProperty.GetAttributes : TPropertyAttributes;
begin
 Result := [paValueList,paSortList];
end;

function TLangFileProperty.GetValue : string;
begin
 Result := GetStrValue;
end;

procedure TLangFileProperty.SetValue(const Value : string);
var
 p :integer;
begin
 p := Pos('.',Value);
 if p = 0
 then SetStrValue(Value)
 else SetStrValue(Copy(Value,1,p-1));
end;

procedure TLangFileProperty.GetValues(Proc : TGetStrProc);
var
 SR : TSearchRec;
 nRes : integer;
 sName : string;
begin
 nRes := FindFirst('*.lng',faAnyFile,SR);
 while nRes = 0 do
 begin
  sName := SR.Name;Delete(sName,Pos('.',sName),4);
  Proc(sName);
  nRes := FindNext(SR);
 end;
 FindClose(SR);
end;

procedure Register;
begin
  RegisterComponents('System', [TkMLang]);
  RegisterPropertyEditor(TypeInfo(string),TkMLang,
                         'LangFileName',TLangFileProperty);
end;

end.
 